; 
    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    include \masm32\macros\macros.asm

; 
    .data
        start_esp dd 0
        bite_size dd 0
        argBuffer db 128 dup (0)
    .code
; 
start:
; 
    invoke GetCL,1,ADDR argBuffer
    invoke atodw,ADDR argBuffer

    ; GetCL returns 0 for no command line ??
    .IF eax == 0
      mov   bite_size,1024
    .ELSE
      mov   bite_size,eax
    .ENDIF
    print chr$("bite_size = ")
    print ustr$(bite_size)
    print chr$(" bytes",13,10)

    mov   start_esp,esp
    print chr$("start_esp = ")
    print ustr$(start_esp)
    print chr$(13,10,13,10)

    jmp   eatstack

    mov   eax,input(13,10,"Press enter to exit...")
    exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

eatstack proc
    sub   esp,bite_size

    assume fs:nothing

    mov   ebx,start_esp
    sub   ebx,esp
    print chr$("start_esp - esp = ")
    print ustr$(ebx)
    print chr$(" bytes",13,10)
    mov   ebx,4
    mov   ebx,fs:[ebx]
    print chr$("fs:[4] = ")
    print ustr$(ebx)
    print chr$(", fs:[8] = ")
    mov   esi,8
    mov   esi,fs:[esi]
    print ustr$(esi)
    sub   ebx,esi
    print chr$(", fs:[4] - fs:[8] = ")
    print ustr$(ebx)
    mov   eax,input(" bytes",13,10,"Press enter to continue...",13,10)
    jmp   eatstack
eatstack endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 
end start
